<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>wsl-n-git-mixed-enviornment</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <p>
      How to setup a development environment where Git from WSL integrates with
      native Windows applications, using the Windows home folder as the WSL home
      and using Git from WSL for all tools.
    </p>
    <p>
      <strong>Note</strong> if using Git for Windows, or any tool on the Windows
      side that does not use Git from WSL then there will likely be problems
      with file permissions inside WSL.
    </p>
    <h2 id="tools">Tools</h2>
    <p>These are the tools I use:</p>
    <ul>
      <li>git (wsl) - Command line git from within WSL.</li>
      <li>
        <a href="https://www.fork.dev">Fork</a> (windows) - Git GUI (must be
        used with <code>wslgit</code>)
      </li>
      <li>
        <a href="https://github.com/andy-5/wslgit">wslgit</a> - Makes git from
        WSL available for Windows applications.
        <strong>Important!</strong> Follow the installation instructions and do
        (at least) the first optional step and then the
        <a href="https://github.com/andy-5/wslgit#usage-in-fork"
          >Usage in Fork</a
        >
        instructions.
      </li>
      <li>
        <a href="http://kdiff3.sourceforge.net/">KDiff3</a> (windows) -
        Diff/merge GUI tool, invoked from git inside wsl.
      </li>
      <li><a href="https://code.visualstudio.com/">VSCode</a> (windows)</li>
      <li>
        A terminal, like
        <a href="https://github.com/mintty/wsltty">wsltty</a> or
        <a href="https://github.com/microsoft/terminal">Windows Terminal</a>
        (windows)
      </li>
    </ul>
    <h1 id="wsl-installation">WSL Installation</h1>
    <ol type="1">
      <li>
        <p>First time? Open <code>PowerShell</code> and run:</p>
        <div class="sourceCode" id="cb1">
          <pre
            class="sourceCode powershell"
          ><code class="sourceCode powershell"><a class="sourceLine" id="cb1-1" title="1">Enable-WindowsOptionalFeature -Online -FeatureName Microsoft-Windows-Subsystem-Linux</a></code></pre>
        </div>
      </li>
      <li>
        <p>
          Download and install a distro from Windows Store, Command-Line or
          manually unpack and install (for Windows Server).
        </p>
      </li>
    </ol>
    <blockquote>
      <p>
        <strong>Important!</strong> Start WSL once directly after installing the
        distribution of choise to finish the installation.
      </p>
    </blockquote>
    <p>
      For full details see
      https://docs.microsoft.com/en-us/windows/wsl/install-win10.
    </p>
    <h2 id="user-name-and-password">User Name and Password</h2>
    <p>
      When selecting a WSL user name you don’t need to use the same name as your
      windows logon. The password can be anything but you must remember it since
      it will be used when sudo-ing.
    </p>
    <p>
      The user name and password in WSL have nothing to do with the Windows user
      name and password, so changing your password in windows does not change
      your password in WSL, or vice versa.<br />
      The password you use in WSL is not critical for security since you still
      need to log on to your windows account to start WSL so it can be an easy
      to remember password.<br />
      However, if you enable access to your WSL via SSH and allow password
      authentication then your WSL password strength will be of importance. But
      don’t allow password authentication, just use pubkey authentication.
    </p>
    <h1 id="wsl-setup">WSL Setup</h1>
    <h2 id="wsl.conf">wsl.conf</h2>
    <p>In WSL, create (or edit) the file <em>/etc/wsl.conf</em>:</p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode ini"
      ><code class="sourceCode ini"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">[automount]</span></a>
<a class="sourceLine" id="cb2-2" title="2"><span class="dt">enabled </span><span class="ot">=</span><span class="st"> </span><span class="kw">true</span></a>
<a class="sourceLine" id="cb2-3" title="3"><span class="dt">root </span><span class="ot">=</span><span class="st"> /</span></a>
<a class="sourceLine" id="cb2-4" title="4"><span class="dt">options </span><span class="ot">=</span><span class="st"> &quot;metadata,umask=</span><span class="dv">022</span><span class="st">,fmask=</span><span class="dv">111</span><span class="st">,case=off&quot;</span></a></code></pre>
    </div>
    <p>
      Restart <em>all</em> active WSL sessions, can be done from cmd or PS using
      the command <code>wsl --shutdown</code>.
    </p>
    <p>
      <code>root = /</code> changes the mount root for windows local drives to
      <em>‘/’</em> instead of the default
      <em>‘/mnt/<em>, so instead of C: mounted at </em>’/mnt/c’</em> it will be
      mounted at <em>‘/c’</em>.
    </p>
    <p>
      <code>case=off</code> will make all directories created from within WSL to
      be <em>case insensitive</em> in the windows file system, because even if
      <a
        href="https://blogs.msdn.microsoft.com/commandline/2018/02/28/per-directory-case-sensitivity-and-wsl/"
        >Windows is case sensitive</a
      >
      the applications run on windows is not necessary case sensitive.
    </p>
    <h3 id="metadata-umask-and-fmask">metadata, umask and fmask</h3>
    <p>
      The <code>metadata</code> option will make it possible to set the owner
      and group of files using chown and modify read/write/execute permissions
      in WSL using chmod. See
      <a
        href="https://devblogs.microsoft.com/commandline/chmod-chown-wsl-improvements/"
        >Chmod/Chown WSL Improvements</a
      >
      for details.
    </p>
    <p>
      The umask and fmask sets the default values of the permissions on files
      and directories of mounted windows drives. The
      <code>umask=022</code> option excludes write permission for group/others
      for files and directories, and the <code>fmask=111</code> option excludes
      execution permission for user/group/others for files, making the default
      mask <code>644</code> on all windows drives mounted automatically by WSL.
      The permissions can be changed by using <code>chmod</code>, which will
      create metadata for a file containing the modified permissions.
    </p>
    <blockquote>
      <p>
        <strong>Important!</strong> This will make <strong>ALL</strong> files
        and directories in <code>/c</code> have <code>644</code> as default
        permissions, meaning that it won’t be possible to execute
        <em>any</em> applications or scripts in the windows drives unless you
        specifically add the execute permission from within WSL
      </p>
    </blockquote>
    <p>
      This is what makes permissions work as expected for the Windows filesystem
      from within WSL instead of every file having the execution bit set, which
      is really annoying, but there are some caveats.
    </p>
    <ol type="1">
      <li>
        To run a Windows application (.exe) you must <code>chmod +x</code> the
        application.
      </li>
      <li>
        To chmod files in <code>C:\Program Files</code> or
        <code>C:\Program Files (x86)</code> the WSL terminal must be started
        using “Run as administrator”. It doesn’t seem to be possible to change
        permissions on files in <code>C:\Windows</code> anymore.
      </li>
    </ol>
    <h4 id="program-xyz.exe-is-not-working-anymore">
      Program Xyz.exe is not working anymore!
    </h4>
    <p>Add the execution permission for the application:</p>
    <pre class="shell"><code>chmod +x /path/to/xyz.exe</code></pre>
    <p>
      Note that all files in <em>‘/c/Windows/’</em>,
      <em>‘/c/Program Files/’</em> and
      <em>‘/c/Program Files (x86)/’</em> requires the WSL terminal to be started
      as administrator to be able to modify the permissions.
    </p>
    <h4 id="scripts-does-not-work-after-git-checkout">
      Scripts does not work after git checkout!
    </h4>
    <p>
      When doing git-checkout from a windows tool and a script file is replaced
      then it <del>might</del> will loose its metadata, which means loosing the
      execution permission. If trying to execute the script you will get a
      <em>Permission denied</em>, and if doing a <code>git diff</code> you will
      just get a difference in mode:
    </p>
    <pre><code>$ git diff
diff --git a/myscript b/myscript
old mode 100755
new mode 100644</code></pre>
    <p>
      Just restore the missing execution permission using
      <code>chmod +x myscript</code> for that file in WSL.
    </p>
    <p>
      You can also do a <code>git checkout -- myfile</code> from within WSL, to
      restore the permissions for that file by checking it out again, but note
      that this will also revert any other changes made to that file.
      <code>git checkout -- .</code> can be useful to restore the permissions on
      several files in the current directory and all subdirectories, but be
      aware that this command will revert <em>ALL</em> changes made to all
      files.
    </p>
    <h2 id="use-windows-home-folder">Use Windows Home Folder</h2>
    <p>In WSL, edit <em>/etc/passwd</em> and change your home folder:</p>
    <pre><code>carl-oskar:x:1000:1000:,,,:/c/Users/user.name:/bin/bash</code></pre>
    <p>
      Close all WSL sessions (<code>wsl --shutdown</code> from cmd/PS) before
      restarting again.
    </p>
    <h3 id="existing-filesfolders-permissions">
      Existing Files/Folders Permissions
    </h3>
    <p>
      If you already have ssh keys and configurations in
      <code>$HOME/.ssh</code> that were created in windows then you must change
      the file permission on those files to 600. Also fix
      <code>$HOME/.gnupg</code> if you are using GnuPG.
    </p>
    <pre class="shell"><code>chmod -R 600 .ssh
chmod -R 600 .gnupg</code></pre>
    <h2 id="share-environment-variables-from-windows-to-wsl">
      Share Environment Variables from Windows to WSL
    </h2>
    <p>
      Windows environment variables are shared to WSL using a special
      environment variable called <code>WSLENV</code> that is a colon-delimited
      list of environment variables. <code>WSLENV</code> can also be used to
      share environment variables from WSL to Windows, useful when executing
      windows applications from WSL.
    </p>
    <p>
      Each variable can be suffixed with a slash followed by flags to specify
      how it is translated, for example <code>/up</code> makes the variable
      available when invoking WSL from Win (<em>p</em> flag) with the path
      translated to WSL paths (<em>u</em> flag).
    </p>
    <p>
      https://devblogs.microsoft.com/commandline/share-environment-vars-between-wsl-and-windows/
    </p>
    <h2 id="optional-tmp-in-ram">(Optional) /tmp in RAM</h2>
    <div class="sourceCode" id="cb7">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb7-1" title="1">$ <span class="bu">echo</span> <span class="st">&quot;tmpfs /tmp tmpfs rw,noatime,nosuid,nodev,size=1G&quot;</span> <span class="kw">|</span> <span class="fu">sudo</span> tee -a /etc/fstab</a></code></pre>
    </div>
    <p>
      The above command will add an entry in fstab that will mount a temporary
      filesystem on <code>/tmp</code> which will use a <em>maximum</em> of
      <strong>1 GB</strong> of RAM. Omitting <em>size</em> will use the default
      max which is half(?) the RAM.
    </p>
    <h1 id="git-setup">GIT Setup</h1>
    <h2 id="wslgit---the-bridge-between-windows-and-git-in-wsl">
      wslgit - the bridge between Windows and git in WSL
    </h2>
    <p>
      Download
      <a href="https://github.com/andy-5/wslgit/releases/latest">wslgit</a>
      (follow the installation instructions!).
    </p>
    <h3 id="speed-up-wslgit">Speed up wslgit</h3>
    <p>
      By default <code>wslgit</code> executes most commands using
      <strong><em>non</em>-interactive</strong> shell which does not execute
      <code>.bashrc</code> etc and therefore is fast.<br />
      But commands that access remotes (<code>clone</code>, <code>fetch</code>,
      <code>push</code>, <code>pull</code>, etc.) are executed using
      <strong>interactive</strong> shell which do run <code>.bashrc</code>. If
      the <code>.bashrc</code> script contains a lot of initializations, like
      starting agents and other time consuming stuff then those commands can
      become slow.
    </p>
    <p>
      The environment variable <code>WSLGIT</code> can be used to detect that
      <code>.bashrc</code> was started by <code>wslgit</code>, and if so only do
      a bare minimum of initialization, just so <code>git</code> can work
      properly, like starting <code>ssh-agent</code> etc.<br />
      If running <code>.bashrc</code> is not required then
      <code>wslgit</code> can be forced to always use
      <strong><em>non</em>-interactive</strong> shell by, in Windows, define an
      environment variable named <code>WSLGIT_USE_INTERACTIVE_SHELL</code> and
      set it to <code>false</code>.
    </p>
    <h2 id="using-kdiff3-for-diff-and-merge">
      Using KDiff3 for diff and merge
    </h2>
    <ol type="1">
      <li>
        Add KDiff3 installation directory to the windows path so that WSL can
        find <code>kdiff3.exe</code> without the full path, makes the
        configuration prettier.
      </li>
      <li>
        <p>
          Create a difftool config in <code>.gitconfig</code> for KDiff3, call
          it “kdiff3”, whose command converts paths from unix-style to windows
          style, and configure it as <code>diff.tool</code>. Also configure
          KDiff3 as mergetool, which does not require any conversion of paths.
        </p>
        <div class="sourceCode" id="cb8">
          <pre
            class="sourceCode ini"
          ><code class="sourceCode ini"><a class="sourceLine" id="cb8-1" title="1"><span class="kw">[diff]</span></a>
<a class="sourceLine" id="cb8-2" title="2"><span class="dt">    guitool </span><span class="ot">=</span><span class="st"> kdiff3</span></a>
<a class="sourceLine" id="cb8-3" title="3"><span class="kw">[difftool]</span></a>
<a class="sourceLine" id="cb8-4" title="4"><span class="dt">    prompt </span><span class="ot">=</span><span class="st"> </span><span class="kw">false</span></a>
<a class="sourceLine" id="cb8-5" title="5"><span class="kw">[difftool &quot;kdiff3&quot;]</span></a>
<a class="sourceLine" id="cb8-6" title="6"><span class="dt">    </span><span class="co"># Unix style paths must be converted to windows path style</span></a>
<a class="sourceLine" id="cb8-7" title="7"><span class="dt">    cmd </span><span class="ot">=</span><span class="st"> kdiff3.exe \&quot;`wslpath -w $LOCAL`\&quot; \&quot;`wslpath -w $REMOTE`\&quot;</span></a>
<a class="sourceLine" id="cb8-8" title="8"><span class="dt">    trustExitCode </span><span class="ot">=</span><span class="st"> </span><span class="kw">false</span></a>
<a class="sourceLine" id="cb8-9" title="9"><span class="kw">[merge]</span></a>
<a class="sourceLine" id="cb8-10" title="10"><span class="dt">    tool </span><span class="ot">=</span><span class="st"> kdiff3</span></a>
<a class="sourceLine" id="cb8-11" title="11"><span class="kw">[mergetool]</span></a>
<a class="sourceLine" id="cb8-12" title="12"><span class="dt">    keepBackup </span><span class="ot">=</span><span class="st"> </span><span class="kw">false</span></a>
<a class="sourceLine" id="cb8-13" title="13"><span class="dt">    prompt </span><span class="ot">=</span><span class="st"> </span><span class="kw">false</span></a>
<a class="sourceLine" id="cb8-14" title="14"><span class="dt">    path </span><span class="ot">=</span><span class="st"> kdiff3.exe</span></a>
<a class="sourceLine" id="cb8-15" title="15"><span class="dt">    trustExitCode </span><span class="ot">=</span><span class="st"> </span><span class="kw">false</span></a></code></pre>
        </div>
      </li>
    </ol>
    <h1 id="vscode-setup">VSCode Setup</h1>
    <h2 id="using-git-from-wsl-in-vscode">Using git from WSL in VSCode</h2>
    <p>
      By using the VSCode plugin <code>Remote - WSL</code> and open a folder “in
      WSL” then VSCode will always use git from WSL, but for folders not opened
      using the Remote WSL then <code>wslgit</code>must be in the Windows Path,
      which it is if you did the optional second step when
      <a href="https://github.com/andy-5/wslgit#installation"
        >installing wslgit</a
      >.
    </p>
    <p>SAVE TO CACHER</p>
  </body>
</html>
